<?php
	/* Runtime configuration */
	define(S2P_PATH_BASE,		dirname(dirname(dirname(dirname(__FILE__)))));
	define(CORE_PATH_BASE,		S2P_PATH_BASE.'/core');
	define(TMP_PATH_BASE,		S2P_PATH_BASE.'/tmp');
	define(APPS_PATH_BASE,		S2P_PATH_BASE.'/apps');
	define(CI_PATH_BASE,		APPS_PATH_BASE.'/castiron');
	define(IGX_PATH_BASE,		APPS_PATH_BASE.'/igx');

	define(CI_PATH_CONFIG,		CI_PATH_BASE.'/config');
	define(CI_PATH_HTDOCS,		CI_PATH_BASE.'/htdocs');
	define(CI_PATH_HTDOCS_INC,	CI_PATH_BASE.'/htdocs/inc');
	define(CI_PATH_PEAR,		CI_PATH_BASE.'/pear');
	define(CI_PATH_LIBS,		CI_PATH_BASE.'/phplibs');
	define(CI_PATH_LANGS,		CI_PATH_BASE.'/langs');
	define(CI_PATH_DATA,		CI_PATH_BASE.'/data');
	define(CI_PATH_LIBEXEC,		CI_PATH_BASE.'/libexec');
	define(CI_PATH_BIN,			CI_PATH_BASE.'/bin');
	define(CI_PATH_MISC,		CI_PATH_BASE.'/misc');

	require_once(CI_PATH_LIBS.'/utils.inc.php');
	require_once(CI_PATH_LIBS.'/auth.inc.php');
	require_once(CI_PATH_PEAR.'/DB.php');

	$CI_CONFIG_SYSTEM		= ci_get_unserialized_xml(CI_PATH_CONFIG.'/system.xml');
	$CI_CONFIG_BRAND		= ci_get_unserialized_xml(CI_PATH_CONFIG.'/brand.xml');
	$CI_CONFIG_USERS		= ci_get_unserialized_xml(IGX_PATH_BASE.'/config/auth/users.xml');
	$CI_CONFIG_GROUPS		= ci_get_unserialized_xml(IGX_PATH_BASE.'/config/auth/groups.xml');
	$CI_CORE_CONFIG_LICENSE	= ci_get_unserialized_xml(CORE_PATH_BASE.'/config/license.xml');
	$CI_CONFIG_IGX			= ci_get_unserialized_xml(IGX_PATH_BASE.'/config/system.xml');
	$CI_CORE_CONFIG			= ci_get_unserialized_xml(CORE_PATH_BASE.'/config/system.xml');

	if (PEAR::isError($CI_CORE_CONFIG_LICENSE)) $CI_CORE_CONFIG_LICENSE=false;

	/* Wrapper: $_SERVER['SERVER_ADDR'], $_SERVER['SERVER_PORT'] */
	if ($_SERVER['SERVER_ADDR'] == '0.0.0.0')
	{
		$foo=split(':', $_SERVER['HTTP_HOST']);
		$_SERVER['SERVER_ADDR']=$foo[0];
		$_SERVER['SERVER_PORT']=$foo[1];
		if (!$_SERVER['SERVER_PORT']) $_SERVER['SERVER_PORT']=80;
	}
	$CI_URI_BASE	= 'http://'.$_SERVER['HTTP_HOST'];

	$CI_LOGIN_INFO=CI_AUTH::get_login_info();
	require_once(CI_PATH_LANGS.'/'.$CI_CORE_CONFIG['language'].'/labels.php');

	$dsn = array(
		'phptype'  => 'sqlite3',
		'database' => IGX_PATH_BASE.'/config/'.$CI_CONFIG_IGX['database'],
		'mode'     => '0666',
	);

	$options = array();

	$CI_DB =& DB::connect($dsn, $options);
	$CI_DB->setFetchMode(DB_FETCHMODE_ASSOC);
?>