<?php
	require_once(CI_PATH_LIBS.'/fields.inc.php');
	require_once(CI_PATH_LIBS.'/buttons.inc.php');
	
	class CI_FORMS
	{
		private $id;
		private $fields;
		private $values;
		private $action;
		private $tab_lbl_prefix;
		private $fld_lbl_prefix;
		private $is_ajax;
		public $buttons;
		
		function CI_FORMS($id=NULL)
		{
			if (is_null($id)) $id=uniqid('form_');
			
			$this->id=$id;
			$this->buttons=new CI_BUTTONS();
			$this->hidden_fields=array();
			$this->is_ajax=true;
		}

		function set_ajax($status)
		{
			$this->is_ajax=$status;
		}

		function set_fields($fields)
		{
			$this->fields=$fields;
		}

		function set_action($action)
		{
			$this->action=$action;
		}

		function set_values($values)
		{
			$this->values=$values;
		}

		function set_tabs_label_prefix($values)
		{
			$this->tab_lbl_prefix=$values;
		}

		function set_fields_label_prefix($values)
		{
			$this->fld_lbl_prefix=$values;
		}

		function set_hidden_fields($fields)
		{
			$this->hidden_fields=$fields;
		}

		function get()
		{
			global $CI_URI_BASE;

			$out ='<form method="POST" class="form" enctype="multipart/form-data" action="'.$CI_URI_BASE.'/'.$this->action.'" id="'.$this->id.'">';

			$out.='<div id="'.$this->id.'_error" style="display: none">';
			$out.='Unknown error';
			$out.='</div>';

			foreach ($this->hidden_fields as $k => $v)
				$out.='<input type="hidden" name="'.$k.'" value="'.htmlspecialchars($v).'" />';
			
			$out.='<div id="'.$this->id.'_accordion" class="form">';

			foreach ($this->fields as $tab => $i)
			{
				if (!$i['label']) $i['label']=$this->tab_lbl_prefix.$tab;
				
				$out.='<div class="form_header_closed">'.ci_lbl($i['label']).'</div>';
				$out.='<div class="form_tab">';

				$out.='<table class="form">';
				$out.='<tbody>';

				foreach ($i['fields'] as $field => $j)
				{
					if (!$j['label']) $j['label']=$this->fld_lbl_prefix.$field;
					if (!$j['value']) $j['value']=$this->values[$field];
				
					$out.='<tr id="'.$field.'">';

					$out.='<td class="form_key">';
					$out.=ci_lbl($j['label']);
					$out.='</td>';

					$out.='<td class="form_value">';
					$out.=CI_FIELDS::get($field, $j);
					$out.='</td>';

					$out.='</tr>';
				}
				
				$out.='</tbody>';
				$out.='</table>';

   				$out.='</div>';
   			}

			$out.=$this->buttons->get();
   			
			$out.='</div>';
			$out.='</form>';

			if ($this->is_ajax)
			{
				$out.='<script type="text/javascript">';

					$out.='var accordion = new Accordion(\'div.form_header_closed\', \'div.form_tab\', {';
						$out.='opacity: true,';
						$out.='onActive: function(toggler, element) {';
							$out.='toggler.className="form_header_open";';
						$out.='},';

						$out.='onBackground: function(toggler, element) {';
							$out.='toggler.className="form_header_closed";';
						$out.='}';
					$out.='}, $(\''.$this->id.'_accordion\'));';

					$out.='$(\''.$this->id.'\').do_submit=function() {';
						$out.='ci_show_loader();';
						$out.='this.send({';
							$out.='onComplete: function(txt, xml) {';
								$out.='res=ci_xml2array(xml);';
								$out.='ci_hide_loader();';
								$out.='if (res["reply"]["type"] == "ok")';
								$out.='{';
									$out.='on_form_event("'.$this->id.'", \'submit_ok\');';
									$out.='ci_blink_success_block("'.$this->id.'_error", 2, "'.ci_lbl('common.success').'");';
								$out.='}';
								$out.='else if (res["reply"]["type"] == "redirect")';
								$out.='{';
									$out.='self.location.href=res["reply"]["params"]["url"];';
								$out.='}';
								$out.='else';
								$out.='{';
									$out.='on_form_event("'.$this->id.'", \'submit_error\');';
									$out.='ci_blink_error_block("'.$this->id.'_error", 2, res["reply"]["params"]["desc"]);';
								$out.='}';
							$out.='}';
						$out.='});';
					$out.='};';

					$out.='$(\''.$this->id.'\').addEvent(\'submit\', function(e) {';
						$out.='new Event(e).stop();';
						$out.='$(\''.$this->id.'\').do_submit();';
					$out.='});';
				$out.='</script>';
			}
			else
			{
				$out.='<script type="text/javascript">';
					$out.='$(\''.$this->id.'\').do_submit=function() {';
						$out.='this.submit();';
					$out.='};';
				$out.='</script>';
			}

			return $out;
		}
	}
?>