<?php
	class CI_SETTINGS_ALERTS extends CI_SETTINGS
	{
		function get_config_file()
		{
			return CI_PATH_CONFIG.'/alerts.xml';
		}

		function get_rmap($info)
		{
			return array(
				'credit' 	=> array(
					'enabled'					=> $info['credit_enabled'],
					'threshold'					=> $info['credit_threshold'],
					'media'						=> $info['credit_media'],
					'message-template-subject'	=> $info['credit_message_subject'],
					'message-template-body'		=> $info['credit_message_body']
				)
			);
		}

		function get_map($info)
		{
			return array(
				'credit_enabled'			=> $info['credit']['enabled'],
				'credit_threshold'			=> $info['credit']['threshold'],
				'credit_media'				=> $info['credit']['media'],
				'credit_message_subject'	=> $info['credit']['message-template-subject'],
				'credit_message_body'		=> $info['credit']['message-template-body']
			);
		}
		
		function get_info()
		{
			$config=ci_get_unserialized_xml($this->get_config_file());
			if (!$config) return array();
			
			return $this->get_map($config);
		}

		function task_save($info)
		{
			if ($info['credit_enabled'] == 'true')
			{
				if (!$info['credit_threshold'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'credit_threshold',
							'desc'		=> ci_lbl('libsettings_alerts.error.missing-credit_threshold')
						)
					);

				if (!$info['credit_media'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'credit_media',
							'desc'		=> ci_lbl('libsettings_alerts.error.missing-credit_media')
						)
					);
			}
			
			ci_save_xml($this->get_config_file(), $this->get_rmap($info));
			return ci_response_ok();
		}
	}
?>