#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import os.path
import string
import re
import time

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-2]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from s2p import *
from s2p_logger import *

S2P_CONF_SYSTEM	= xml_to_array(CORE_PATH_CONFIG+'/system.xml')

##########################################################################################
# Verifica dati in ingresso
if len(sys.argv) < 2:
	print "Usage: "+sys.argv[0]+" username"
	sys.exit(-1)

S2P_CONF_SKYPE	= xml_to_array(CORE_PATH_CONFIG+'/skype.xml', 0)

# Lettura dati
user_name=sys.argv[1]

# Validazione dati
if not re.match(r'^[\w\-_\.]+$', user_name) or re.match(r'^\.', user_name):
	print "Dangerous username"
	sys.exit(-1)

# Ricerca info utente
#S2P_USER_INFO=0

#for item in S2P_CONF_SKYPE['item'].values():
	#if item['+']['skype'][0]['+']['username'][0]['#'] == user_name:
		#S2P_USER_INFO=xml_simplify_array(item)
		#break

#if not S2P_USER_INFO:
	#print "Unknown user"
	#sys.exit(-1)

#if S2P_USER_INFO['enabled'] != "true":
#	print "User is disabled"
#	sys.exit(-1)

##########################################################################################
# Ricerca processi

processes_list=[
	'connect.py',
	'manage',
	'skype_connector',
	S2P_CONF_SYSTEM['bin']['skype']
]

if S2P_CONF_SYSTEM['bin'].has_key('wm'): processes_list.append(S2P_CONF_SYSTEM['bin']['wm'])
if S2P_CONF_SYSTEM['bin'].has_key('vnc'): processes_list.append(S2P_CONF_SYSTEM['bin']['vnc'])
if S2P_CONF_SYSTEM['bin'].has_key('vfb'): processes_list.append(S2P_CONF_SYSTEM['bin']['vfb'])

# Individuazione processi
pids_to_kill=[]
s2p_socket=""

for key in processes_list:
	
	# Controllo di sicurezza PID reale
	psax_out=systempt("ps ax |grep "+os.path.basename(key)+"|grep -v grep")
	psax_lines=re.split(r'[\r\n]+', psax_out)

	for psax_line in psax_lines:
		psax_line=re.sub(r'^\s*', '', psax_line)+' '

		if psax_line.find(' '+key+' ') == -1 and psax_line.find('/'+key+' ') == -1: continue

		[pid, info]=re.split(r'\s+', psax_line, 1)

		if os.path.isfile('/proc/'+pid+'/environ'):
			env_s2p_user=systempt('cat /proc/'+pid+r'/environ | tr "\000" "\n" |grep S2P_USER_SKYPE=|cut -d= -f2')

			if env_s2p_user == user_name:
				os.system("kill "+str(pid))
				s2p_socket=systempt('cat /proc/'+pid+r'/environ | tr "\000" "\n" |grep S2P_SOCKET_SKYPE=|cut -d= -f2')
				break

# Rimozione del socket di controllo
if len(s2p_socket):
	try:
		os.unlink(s2p_socket)
	except:
		1
